--- a/lib/pngstream.cc
+++ b/lib/pngstream.cc
@@ -83,7 +83,12 @@
 #if HAVE_PNG_H
     set_error_handler (_png, _info);
 
+/* when not interlacing (ie, only one pass), number of rows is image height:  _v_sz */
+#if PNG_LIBPNG_VER > 10499
+     if (!_footer && _v_sz == lib->get_current_row_number(_png))
+#else
     if (_header && !_footer && _png->num_rows == _png->flush_rows)
+#endif
       {
         lib->write_end (_png, _info);
         _footer = true;
@@ -167,6 +172,9 @@
     funcsym (write_row);
     funcsym (write_flush);
     funcsym (write_end);
+#if PNG_LIBPNG_VER > 10499
+    funcsym (get_current_row_number);
+#endif
 
     if (lib->access_version_number
         && lib->create_write_struct
@@ -176,6 +184,9 @@
         && lib->set_IHDR
         && lib->set_pHYs
         && lib->set_invert_mono
+#if PNG_LIBPNG_VER > 10499
+        && lib->get_current_row_number
+#endif
         && lib->write_info
         && lib->write_row
         && lib->write_flush
--- a/lib/pngstream.hh
+++ b/lib/pngstream.hh
@@ -108,6 +108,10 @@
                png_structp);
       fundecl (void, write_end,
                png_structp, png_infop);
+#if PNG_LIBPNG_VER > 10499
+      fundecl (png_uint_32, get_current_row_number,
+               png_structp);
+#endif
 #endif /* HAVE_PNG_H */
     };
     static png_lib_handle *lib;
